//
//  Room A Extension
//
//  Written : Priyank Patel <pkpatel@cs.stanford.edu>
//  Simple extension used to determine whether the user has access to the 
//  room A.
//

package Chat;

import java.util.*;

import iaik.x509.*;
import iaik.asn1.*;
import iaik.x509.extensions.*;

public class RoomAExtension extends V3Extension
{
  //Used to identify this extension in an X509Certificate Object
  public static final ObjectID oid = new ObjectID("1.2.3.4.5.1",
						  "RoomA",
						  "RoomA");

  BOOLEAN value;
  
  RoomAExtension(BOOLEAN a)
  {
    value = a;
  }
  
  public ObjectID getObjectID()
  {
    return oid;
  }

  public void init(ASN1Object a)
  {
    value = (BOOLEAN)a;
  }

  public int hashCode()
  {
    return oid.hashCode();
  }

  //Use this function to get the value
  public ASN1Object toASN1Object()
  {
    return value;
  }
}
